Description

A good chunk of our unit tests are testing whether a validation is working or not by testing it actively. For the validations we've added

ourselves I would say it's fine. However for validations that come from the Rails framework, we're essentially testing their job. Instead

of testing (for instance) validates(:name, :uniqueness => true) by creating two objects and verifying the second one won't save (these

tests are already done at the framework level), we should simply test we're including validations in our models.

The well-maintained gem shoulda-matchers provide easy functions to check we're including such validations, and other helpers we

can use to refactor our tests further and not test Rails functionality twice.

Related issues:

Related to Foreman - Bug #13272: Basic edit test can fail when fixtures don't... Closed 01/19/2016

Associated revisions

Revision d6c08a7a - 01/13/2016 03:24 AM - Daniel Lobato Garcia

Fixes #11618 - Replace validation tests by shoulda-matchers

A good chunk of our unit tests are testing whether a validation is

working or not by testing it actively. For the validations we've

added ourselves I would say it's fine. However for validations that

come from the Rails framework, we're essentially testing their job.

Instead of testing (for instance) validates(:name, :uniqueness =>

true) by creating two objects and verifying the second one won't

save (these tests are already done at the framework level), we

should simply test we're including validations in our models.

The well-maintained gem shoulda-matchers provide easy functions to

check we're including such validations, and other helpers we can

use to refactor our tests further and not test Rails functionality

twice.

History

#1 - 08/31/2015 05:30 AM - The Foreman Bot

- Status changed from New to Ready For Testing

- Pull request https://github.com/theforeman/foreman/pull/2651 added

- Pull request deleted ()

#2 - 01/13/2016 03:14 AM - Dominic Cleal

- translation missing: en.field_release set to 71

#3 - 01/13/2016 04:02 AM - Daniel Lobato Garcia

- Status changed from Ready For Testing to Closed

- % Done changed from 0 to 100
Applied in changeset d6c08a7ac2c23c967bbabda745ef7311a955107a.

#4 - 01/20/2016 08:09 AM - Dominic Cleal

- Related to Bug #13272: Basic edit test can fail when fixtures don't exist for a particular model added
